Web/Web/Controllers/BlackListController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using System.Threading.Tasks;
using Web.Interfaces;
using Web.Models;

namespace Web.Areas.WebApp.Controllers
{
    [Authorize(Roles = "Admin")]
    public class BlackListController : Controller
    {
        IBadLinkService badLinkService;

        public BlackListController(IBadLinkService badLinkService)
        {
            this.badLinkService = badLinkService;
        }

        [HttpGet]
        public async Task<IActionResult> BadLinks()
        {
            return View(await badLinkService.GetBadLinksAsync());
        }

        [HttpGet]
        public IActionResult Create()
        {
            return PartialView("Edit");
        }

        [HttpGet]
        public IActionResult Update(int id)
        {
            return PartialView("Edit", badLinkService.GetBadLinkAsync(id));
        }

        [HttpPost]
        public async Task<IActionResult> Edit(BadLink link)
        {
            if (ModelState.IsValid)
            {
                //uniqueness check
                if (!await badLinkService.CheckLink(link.Url))
                {
                    ModelState.AddModelError("Url", "Такая ссылка уже есть");
                    return PartialView(link);
                }
                if (link.Id == 0)
                {
                    await badLinkService.CreateAsync(link);
                }
                else
                {
                    await badLinkService.UpdateAsync(link);
                }
            }
            return PartialView(link);
        }

        [HttpGet]
        public async Task<IActionResult> Delete(int id)
        {
            return PartialView(await badLinkService.GetBadLinkAsync(id));
        }

        [HttpPost]
        [ActionName("Delete")]
        public async Task<IActionResult> DeletePost(int id)
        {
            await badLinkService.DeleteAsync(id);
            return PartialView(new BadLink() { Id = id });
        }

        [HttpGet]
        public async Task<IActionResult> Index()
        {
            return View(await badLinkService.GetBadLinksAsync());
        }
    }
}

Web/Web/Controllers/LinkController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Claims;
using System.Threading.Tasks;
using Web.Converter;
using Web.Interfaces;
using Web.Models;

namespace Web.Areas.WebApp.Controllers
{
    [Authorize]
    //[Authorize(Roles = "admin, user")]
    public class LinkController : Controller
    {
        /// <summary>
        /// current user id
        /// </summary>
        string UserId
        {
            get
            {
                return userManager.GetUserId(User);
            }
        }

        private readonly UserManager<User> userManager;
        private readonly ILinkService linkService;
        private readonly IProjectService projectService;
        private readonly IBadLinkService badLinkService;

        public LinkController(UserManager<User> userManager, ILinkService linkService, IProjectService projectService, IBadLinkService badLinkService)
        {
            this.userManager = userManager;
            this.linkService = linkService;
            this.projectService = projectService;
            this.badLinkService = badLinkService;
        }

        [HttpGet]
        public async Task<ActionResult> Links(int projectId)
        {
            Project project = await projectService.GetProjectAsync(projectId);
            project.Links = await projectService.GetLinksAsync(projectId);
            return View(project);
        }

        //public async Task<ActionResult> AllLinks()
        //{
        //    return View(await linkService.GetAvailableLinksAsync());
        //}

        public async Task<ActionResult> UserLinks()
        {
            return View(await linkService.GetUserLinksAsync(UserId));
        }

        [HttpGet]
        public async Task<ActionResult> Search(string? Name, string? DateBegin, string? DateEnd, string SortType)
        {
            List<Link> links = await linkService.GetUserLinksAsync(UserId);
            if (!string.IsNullOrEmpty(Name))
                links = links.Where(l => l.Name.Contains(Name)).ToList();
            if (!string.IsNullOrEmpty(DateBegin))
            {
                DateTime date = DateTime.Parse(DateBegin);
                links = links.Where(l => l.DateCreate > date).ToList();
            }
            if (!string.IsNullOrEmpty(DateEnd))
            {
                DateTime date = DateTime.Parse(DateEnd);
                links = links.Where(l => l.DateCreate < date).ToList();
            }
            if (!string.IsNullOrEmpty(SortType))
            {

                switch (SortType)
                {
                    case "Name":
                        links = links.OrderBy(l => l.Name).ToList();
                        break;
                    case "CountClick":
                        links = links.OrderBy(l => l.CountClick).ToList();
                        break;
                    case "DateCreate":
                        links = links.OrderBy(l => l.DateCreate).ToList();
                        break;
                }
            }
            return View("LinkSearch", links);
        }

        /// <summary>
        /// Redirects to site 
        /// </summary>
        /// <response code="200">Redirect</response>
        /// <response code="200">Link mot found</response>
        [ProducesResponseType(StatusCodes.Status200OK)]
        [ProducesResponseType(StatusCodes.Status404NotFound)]
        [AllowAnonymous]
        [Route("i{shortId}")]
        [HttpGet]
        public async Task<IActionResult> Follow(string shortId)
        {
            int linkId = ShortStringConverter.StringToInt(shortId);

            Link link = await linkService.GetLinkAsync(linkId);
            if (link == null)
                return NotFound();
            if (link.IsActive)
            {
                link.CountClick++;
                await linkService.UpdateAsync(link);
                return Redirect(link.Url);
            }
            else
                return NotFound();
        }

        [HttpGet]
        public async Task<IActionResult> Edit(int id)
        {
            Link link = await linkService.GetLinkAsync(id);
            if (link != null && await projectService.CheckUser(UserId, link.ProjectId))
                return PartialView(link);
            return new NotFoundResult();
        }

        [HttpGet]
        public IActionResult Create(int projectId)
        {
            return PartialView("Edit", new Link() { ProjectId = projectId });
        }

        [HttpPost]
        public async Task<IActionResult> Edit(Link link)
        {
            if (ModelState.IsValid)
            {
                Project project = await projectService.GetProjectAsync(link.ProjectId);
                if(project==null)
                    ModelState.AddModelError("ProjectId", "Такого проекта нет");
                else
                if (!UserId.Equals(project.UserId))
                    ModelState.AddModelError("ProjectId", "Нет доступа");
                else
                if (!await badLinkService.CheckLink(link.Url))
                    ModelState.AddModelError("Url", "Данная ссылка запрещена");
                else
                if (link.Id != 0)
                    await linkService.UpdateAsync(link);
                else
                {
                    link.DateCreate = DateTime.Now;
                    await linkService.CreateAsync(link);
                }
            }
            return PartialView(link);
        }

        /// <summary>
        /// project links
        /// </summary>
        [HttpGet]
        public async Task<IActionResult> LinkProject(int projectId)
        {
            Project project = await projectService.GetProjectAsync(projectId);
            if (project != null && await projectService.CheckUser(UserId, projectId))
            {
                project.Links = await projectService.GetLinksAsync(projectId);
                return PartialView(project);
            }
            else
            {
                ModelState.AddModelError("", "нет доступа");
                return new NotFoundResult();
            }
        }

        [HttpGet]
        public async Task<IActionResult> Delete(int id)
        {
            Link link = await linkService.GetLinkAsync(id);
            if (IsAdmin() || await projectService.CheckUser(UserId, link.ProjectId))
            {
                return PartialView(link);
            }
            else
            {
                ModelState.AddModelError("", "нет доступа");
                return PartialView(new Link());
            }
        }

        [HttpPost]
        public async Task<IActionResult> Delete(Link link)
        {
            if (IsAdmin() || await linkService.CheckUser(UserId, link.Id))
                await linkService.DeleteAsync(link.Id);
            else
                ModelState.AddModelError("", "нет доступа");
            return PartialView(link);
        }

        [HttpGet]
        public async Task<IActionResult> LinksJSON(int? ProjectId)
        {
            if (ProjectId is null)
            {
                return Json(await linkService.GetUserLinksAsync(UserId));
            }
            else
            {
                int id = ProjectId ?? default(int);

                if (!await projectService.CheckUser(UserId, id))
                    return new NotFoundResult();

                return Json(await projectService.GetLinksAsync(id));
            }
        }

        //  checks that the current user is the admin
        private bool IsAdmin()
        {
            bool a = User.FindFirst(x => x.Type == ClaimsIdentity.DefaultRoleClaimType).Value == "Admin";
            return a;
            //// Get the roles for the user
            //var user = await userManager.FindByNameAsync(User.Identity.Name);
            //var roles = await userManager.GetRolesAsync(user);
            //return await userManager.IsInRoleAsync(user, "Admin");
            ////return roles.Contains("Admin");
        }
    }
}

Web/Web/Controllers/ProjectController.cs
using Authorization.FacebookDemo.Data;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Threading.Tasks;
using Web.Interfaces;
using Web.Models;
namespace Web.Areas.WebApp.Controllers
{
    [Authorize]
    //[Authorize(Roles = "admin, user")]
    public class ProjectController : Controller
    {
        /// <summary>
        /// current user id
        /// </summary>
        string UserId
        {
            get
            {
                return userManager.GetUserId(User);
            }
        }

        readonly IProjectService projectService;
        readonly UserManager<User> userManager;

        public ProjectController(IProjectService projectService, UserManager<User> userManager)
        {
            //Databaseinitializer.Init(userManager);
            this.projectService = projectService;
            this.userManager = userManager;
        }

        [HttpGet]
        public async Task<IActionResult> Index()
        {
            return View(await projectService.GetProjectsAsync(UserId));
        }

        [HttpGet]
        public async Task<IActionResult> Projects()
        {
            return View(await projectService.GetProjectsAsync(UserId));
        }

        [HttpGet]
        public async Task<IActionResult> ProjectsJSON()
        {
            return Json(await projectService.GetProjectsAsync(UserId));
        }

        [HttpGet]
        public IActionResult Create()
        {
            string userId = userManager.GetUserId(User);
            return PartialView("Edit", new Project() { UserId = userId });
        }

        [HttpGet]
        public async Task<IActionResult> Edit(int id)
        {
            Project project = await projectService.GetProjectAsync(id);
            if (project != null && project.UserId == UserId)
                return PartialView(project);
            else
                return new NotFoundResult();
        }

        [HttpPost]
        public async Task<IActionResult> Edit(Project project)
        {
            if (ModelState.IsValid)
            {
                if (project.Id == 0)
                {
                    project.UserId = userManager.GetUserId(User);
                    project.DateCreate = DateTime.Now;
                    await projectService.CreateAsync(project);
                }
                else
                if (!await projectService.CheckUser(UserId, project.Id))
                    ModelState.AddModelError("", "У вас нет доступа!");
                else
                    await projectService.UpdateAsync(project);
            }
            return PartialView(project);
        }

        [HttpGet]
        [ActionName("Delete")]
        public async Task<IActionResult> ViewDeleteAsync(int id)
        {
            Project project = new Project();
            if (!await projectService.CheckUser(UserId, id))
                ModelState.AddModelError("", "У вас нет доступа!");
            else
                project = await projectService.GetProjectAsync(id);
            return PartialView(project);
        }

        [HttpPost]
        public async Task<IActionResult> Delete(Project project)
        {
            if (!await projectService.CheckUser(UserId, project.Id))
                ModelState.AddModelError("", "У вас нет доступа!");
            else
                await projectService.DeleteAsync(project.Id);
            return PartialView(project);
        }
    }
}

Web/Web/Controllers/StatisticsController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;

namespace Web.Areas.WebApp.Controllers
{
    [Authorize]
    public class StatisticsController : Controller
    {
        [HttpGet]
        public IActionResult Statistics()
        {
            return View();
        }
    }
}

Web/Web/Views/Shared/_AuthorizetionLayout.cshtml
<!DOCTYPE html>

<html>
<head>
    <meta name="viewport" content="width=device-width" />
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
    <link rel="stylesheet" href="~/css/AuthorizationStyle.css" />
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    
    <title>@ViewBag.Title</title>
</head>
<body>
    <header class="text-center">LINK MANAGER</header>
    <div class="AllHeight row align-items-center justify-content-center w-100">
        <div>
            @RenderBody()
        </div>
    </div>
    <footer class="border-top footer text-muted">
        <div class="container">
            <a class="mr-auto" asp-controller="swagger" asp-action="index" target="_blank">
                Swagger
            </a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @RenderSection("Scripts", required: false)
</body>
</html>

Web/Web/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - Web</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
    <link rel="stylesheet" href="~/css/Style.css" />
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Lato" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-berween">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Project" asp-action="Index">Проекты</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Link" asp-action="UserLinks">Все ваши ссылки</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Statistics" asp-action="Statistics">Статистика</a>
                        </li>
                    </ul>                    
                    <ul class="navbar-nav" asp-authorize asp-roles="Admin">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="BlackList" asp-action="Index">Запретные ссылки</a>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container d-flex justify-content-between">
            <a class="" asp-controller="swagger" asp-action="index" target="_blank">
                Swagger
            </a>
            <div>Вы вошли как 
                <q>@User.Identity.Name</q>
                <a asp-action="Logout" asp-controller="Account" class="text-danger ml-3">Выйти</a>
            </div>
            
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/lib/jquery-ajax-unobtrusive/jquery.unobtrusive-ajax.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @RenderSection("Scripts", required: false)
</body>
</html>